// pnPlugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "resource.h"
#include "pnPlugin.h"
#include "cv.h"
#include "math.h"
#include <commdlg.h> 

static COLORREF couleurContours= 0x000000ff;
static COLORREF oldCouleur= 0x000000ff;
static int selectedMode = 0;
static int oldMode = 0;
static char szPath[255];

plInfo Info = 
	{"0.4.0",
	"seuil",
	"contours",
	"visualisation des contours en superposition de l'image"
	};


void changeCouleur (HWND hwnd, COLORREF * pCouleur)
{
// structure CHOOSECOLOR
	CHOOSECOLOR cc;
	static COLORREF acrCustClr[16];

	ZeroMemory(&cc, sizeof(CHOOSECOLOR));
	cc.lStructSize = sizeof(CHOOSECOLOR);
	cc.hwndOwner = hwnd; 
	cc.lpCustColors = NULL;
	cc.lpCustColors = (LPDWORD) acrCustClr;
	cc.rgbResult = *pCouleur;
	cc.Flags = CC_PREVENTFULLOPEN | CC_RGBINIT;

// appel de la fonction ChooseColor pour ouvrir la bote de dialogue : 

	if (ChooseColor(&cc)==TRUE)
		{
			*pCouleur = cc.rgbResult;
		}
}

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	char strCouleur[80];
	char strMode[80];
	char *c;
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
			c=szPath+GetModuleFileName(0,szPath,255);
			while (*c != '\\') c--;
				*c =0;
			strcat(szPath,"\\PortaNum.ini");
			GetPrivateProfileString("Contours","couleur","255",strCouleur,80,szPath); //"PortaNum.ini"
			couleurContours =(COLORREF) atoi(strCouleur);
			GetPrivateProfileString("Contours","mode","0",strMode,80,szPath);
			selectedMode =atoi(strMode);
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			itoa(couleurContours,strCouleur,10);
			itoa(selectedMode,strMode,10);
			WritePrivateProfileString("Contours","couleur",strCouleur,szPath);
			WritePrivateProfileString("Contours","mode",strMode,szPath);
			break;
    }
    return TRUE;
}


PNPLUGIN_API const char* PnPluginAppName( void )
{
    //version;
    const char * appName;
    appName = "PortaNum";
    return appName;
}

PNPLUGIN_API int PnPluginInfo(plInfo * pInfo )
{
	if (pInfo) 
	{*pInfo = Info;
    return 0;
	}
	else return 1;
}

BOOL CALLBACK AboutDlgProc(HWND hDlg, UINT message,WPARAM wParam,LPARAM lParam)
{
	int radioSel;
	switch (message)
	{
	case WM_INITDIALOG :
         oldMode = selectedMode;
		 oldCouleur = couleurContours;
		switch (selectedMode) {
		case 0:
			radioSel = IDC_RADIO1;
			break;
		case 1:
			radioSel = IDC_RADIO2;
			break;
		case 2:
			radioSel = IDC_RADIO3;
			break;
		case 3:
			radioSel = IDC_RADIO4;
			break;
		default:
			radioSel = IDC_RADIO1;
			break;
		}
		CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO4, radioSel);
		return true;

	case WM_COMMAND:
		switch (LOWORD (wParam))
			{
			case IDC_RADIO1:
				selectedMode = 0;
			break;
			case IDC_RADIO2:
				selectedMode = 1;
			break;
			case IDC_RADIO3:
				selectedMode = 2;
			break;
			case IDC_RADIO4:
				selectedMode = 3;
			break;
			case IDC_BUTTON1:
				changeCouleur (hDlg, &couleurContours);
			break;
            case IDCANCEL:
                 selectedMode = oldMode;
				 couleurContours = oldCouleur;
			case IDOK:			
				EndDialog(hDlg,0);
				return true;
			}
			break;

		}
		return FALSE;
}

PNPLUGIN_API IppStatus PnPluginDialog(HINSTANCE hInstance, HWND hwnd)
{	char buffer[128];
	LPSTR lpstrPrompt = &buffer[0];
	int res = DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),hwnd, AboutDlgProc);
	if (res == -1 ) { 
		MessageBox(NULL,lpstrPrompt,"",NULL);
		return 1; // pas de page de config
	}
	return 0; // ok
}


PNPLUGIN_API IppStatus PnPluginFunction( Ipp8u* pSrc, int srcStep, Ipp8u* pDst, int dstStep, IppiSize roiSize, int mode, int coef )
{
    IppStatus status = 0;  // 0 = no error
	Ipp8u * pS = pSrc;
	Ipp8u * pD = pDst;

	 double maxValue = 255.0;
    int adaptiveMethod = CV_ADAPTIVE_THRESH_GAUSSIAN_C; //CV_ADAPTIVE_THRESH_MEAN_C ;   //CV_ADAPTIVE_THRESH_GAUSSIAN_C
    int thresholdType = CV_THRESH_BINARY ; //CV_THRESH_BINARY ;  // CV_THRESH_BINARY_INV
    int blockSize = 11;    //7
    double param1 = 5.0 * exp( 0.02 * coef );

	IplImage* im1 = NULL;
	IplImage* im2 = NULL;
	IplImage* im3 = NULL;
	IplImage* im4 = NULL;

	CvSize imSize;
	imSize.width = roiSize.width;
	imSize.height = roiSize.height;

	im1 = cvCreateImage( imSize, IPL_DEPTH_8U, 1 );	 // image luminance d'origine
	im2 = cvCreateImage( imSize, IPL_DEPTH_8U, 1 );  // image contours monochrome
	im3 = cvCreateImage( imSize, IPL_DEPTH_8U, 3 );  // image couleur d'origine
	im4 = cvCreateImage( imSize, IPL_DEPTH_8U, 3 );	 // image de destination

	CopyMemory( im3->imageData, pSrc, srcStep * roiSize.height );
	cvCvtColor( im3, im1, CV_BGR2GRAY );

	// version seuil adaptatif
	cvAdaptiveThreshold( im1, im2, maxValue, adaptiveMethod, thresholdType, blockSize, param1 );

	// inverser et mettre les contours dans im1
	cvNot(im2,im1);

	// filtrer l'image d'origine
	switch (selectedMode) {
	case 0:
		cvSmooth(im3,im4, CV_GAUSSIAN, 3,3,0);
		break;
	case 1:
		cvSmooth(im3,im4, CV_GAUSSIAN, 7,7,0);
		break;
	case 2:
		cvCopy(im3,im4);
		break;
	case 3:
		cvSet(im4,cvScalarAll(255),NULL);
		break;
			}

	// traiter les trois canaux
	cvSplit(im4,NULL,NULL,im2,NULL);
	cvSet(im2,cvScalar(GetRValue(couleurContours)),im1);
	cvCvtPlaneToPix(NULL,NULL, im2,NULL,im4 );
		
	cvSplit(im4,NULL,im2,NULL,NULL);
	cvSet(im2,cvScalar(GetGValue(couleurContours)),im1);
	cvCvtPlaneToPix(NULL,im2,NULL,NULL,im4 );

	cvSplit(im4,im2,NULL,NULL,NULL);
	cvSet(im2,cvScalar(GetBValue(couleurContours)),im1);
	cvCvtPlaneToPix(im2,NULL,NULL,NULL,im4 );

	CopyMemory( pDst, im4->imageData, srcStep * roiSize.height );

	
    cvReleaseImage( &im1 );
    cvReleaseImage( &im2 );
	cvReleaseImage( &im3 );
    cvReleaseImage( &im4 );  

    return status;
}
